petsc-3.6.2 2015-10-02
Report Typos and Errors

# KSPComputeExtremeSingularValues

Computes the extreme singular values for the preconditioned operator. Called after or during KSPSolve().

### Synopsis

    #include "petscksp.h"
    PetscErrorCode  KSPComputeExtremeSingularValues(KSP ksp,PetscReal *emax,PetscReal *emin)

Not Collective

### Input Parameter

ksp -iterative context obtained from KSPCreate()

### Output Parameters

emin, emax -extreme singular values

### Options Database Keys

-ksp_compute_singularvalues -compute extreme singular values and print when KSPSolve completes.

### Notes

One must call KSPSetComputeSingularValues() before calling KSPSetUp() (or use the option -ksp_compute_eigenvalues) in order for this routine to work correctly.

Many users may just want to use the monitoring routine KSPMonitorSingularValue() (which can be set with option -ksp_monitor_singular_value) to print the extreme singular values at each iteration of the linear solve.

Estimates of the smallest singular value may be very inaccurate, especially if the Krylov method has not converged. The largest singular value is usually accurate to within a few percent if the method has converged, but is still not intended for eigenanalysis.

Disable restarts if using KSPGMRES, otherwise this estimate will only be using those iterations after the last restart. See KSPGMRESSetRestart() for more details.

### Keywords

KSP, compute, extreme, singular, values

### See Also

KSPSetComputeSingularValues(), KSPMonitorSingularValue(), KSPComputeEigenvalues()

Level:advanced
Location:src/ksp/ksp/interface/itfunc.c
Index of all KSP routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/ksp/examples/tutorials/ex56.c.html